#include <devices/keymap.h>

UBYTE LoKeyMapTypes[64] = {
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KCF_NOP,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KCF_NOP,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KCF_NOP,
	KCF_NOP,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KCF_NOP,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KCF_NOP,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA,
	KC_VANILLA
};

UBYTE LoKeyMap[64][4] = {
	{0xFE, 0xE0,  '~',  '`' },
	{0xA1, 0xB1,  '!',  '1' },
	{0xC0, 0xB2,  '@',  '2' },
	{0xA3, 0xB3,  '#',  '3' },
	{0xA4, 0xB4,  '$',  '4' },
	{0xA5, 0xB5,  '%',  '5' },
	{0xDE, 0xB6,  '^',  '6' },
	{0xA6, 0xB7,  '&',  '7' },
	{0xAA, 0xB8,  '*',  '8' },
	{0xA8, 0xB9,  '(',  '9' },
	{0xA9, 0xB0,  ')',  '0' },
	{0xDF, 0xAD,  '_',  '-' },
	{0xAB, 0xBD,  '+',  '=' },
	{0xFC, 0xDC,  '|',  '\\' },
	{0x00, 0x00, 0x00, 0x00 },
	{0xB0, 0xB0,  '0',  '0' },
	{0xD1, 0xF1,  'Q',  'q' },
	{0xD7, 0xF7,  'W',  'w' },
	{0xC5, 0xE5,  'E',  'e' },
	{0xD2, 0xF2,  'R',  'r' },
	{0xD4, 0xF4,  'T',  't' },
	{0xD9, 0xF9,  'Y',  'y' },
	{0xD5, 0xF5,  'U',  'u' },
	{0xC9, 0xE9,  'I',  'i' },
	{0xCF, 0xEF,  'O',  'o' },
	{0xD0, 0xF0,  'P',  'p' },
	{0xFB, 0xDB,  '{',  '[' },
	{0xFD, 0xDD,  '}',  ']' },
	{0x00, 0x00, 0x00, 0x00 },
	{0xB1, 0xB1,  '1',  '1' },
	{0xB2, 0xB2,  '2',  '2' },
	{0xB3, 0xB3,  '3',  '3' },
	{0xC1, 0xE1,  'A',  'a' },
	{0xD3, 0xF3,  'S',  's' },
	{0xC4, 0xE4,  'D',  'd' },
	{0xC6, 0xE6,  'F',  'f' },
	{0xC7, 0xE7,  'G',  'g' },
	{0xC8, 0xE8,  'H',  'h' },
	{0xCA, 0xEA,  'J',  'j' },
	{0xCB, 0xEB,  'K',  'k' },
	{0xCC, 0xEC,  'L',  'l' },
	{0xBA, 0xBB,  ':',  ';' },
	{0xA2, 0xA7,  '"',  '\'' },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0xB4, 0xB4,  '4',  '4' },
	{0xB5, 0xB5,  '5',  '5' },
	{0xB6, 0xB6,  '6',  '6' },
	{0x00, 0x00, 0x00, 0x00 },
	{0xDA, 0xFA,  'Z',  'z' },
	{0xD8, 0xF8,  'X',  'x' },
	{0xC3, 0xE3,  'C',  'c' },
	{0xD6, 0xF6,  'V',  'v' },
	{0xC2, 0xE2,  'B',  'b' },
	{0xCE, 0xEE,  'N',  'n' },
	{0xCD, 0xED,  'M',  'm' },
	{0xBC, 0xAC,  '<',  ',' },
	{0xBE, 0xAE,  '>',  '.' },
	{0xBF, 0xAF,  '?',  '/' },
	{0x00, 0x00, 0x00, 0x00 },
	{0xAE, 0xAE,  '.',  '.' },
	{0xB7, 0xB7,  '7',  '7' },
	{0xB8, 0xB8,  '8',  '8' },
	{0xB9, 0xB9,  '9',  '9' }
};

UBYTE LoCapsable[8] = {
	0x00, 0x00, 0xFF, 0x03, 0xFF, 0x01, 0xFE, 0x00
};

UBYTE LoRepeatable[8] = {
	0xFF, 0xBF, 0xFF, 0xEF, 0xFF, 0xEF, 0xFF, 0xF7
};

UBYTE HiKeyMapTypes[40] = {
	KCF_ALT,
	KC_NOQUAL,
	KCF_STRING | KCF_SHIFT,
	KC_NOQUAL,
	KCF_CONTROL,
	KCF_ALT,
	KC_NOQUAL,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_ALT,
	KCF_NOP,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_STRING | KCF_SHIFT,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_STRING,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP,
	KCF_NOP
};

UBYTE HiKeyMap[40][4] = {
	{0x00, 0x00, 0xA0,  ' ' },
	{0x00, 0x00, 0x00, 0x08 },
	{0x00, 0xFE, 0x86, 0x0C },
	{0x00, 0x00, 0x00, 0x0D },
	{0x00, 0x00, 0x0A, 0x0D },
	{0x00, 0x00, 0x9B, 0x1B },
	{0x00, 0x00, 0x00, 0x7F },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0xFF,  '-' },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0xFE, 0x86, 0x13 },
	{0x00, 0xFE, 0x86, 0x1B },
	{0x00, 0xFE, 0x86,  '#' },
	{0x00, 0xFE, 0x86,  ',' },
	{0x00, 0xFE, 0x86,  '5' },
	{0x00, 0xFE, 0x86,  '@' },
	{0x00, 0xFE, 0x86,  'K' },
	{0x00, 0xFE, 0x86,  'V' },
	{0x00, 0xFE, 0x86,  'a' },
	{0x00, 0xFE, 0x86,  'l' },
	{0x00, 0xFE, 0x86,  'w' },
	{0x00, 0xFE, 0x86, 0x82 },
	{0x00, 0xFE, 0x86, 0x8D },
	{0x00, 0xFE, 0x86, 0x98 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0xFE, 0x86, 0xA3 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 },
	{0x00, 0x00, 0x00, 0x00 }
};

UBYTE HiCapsable[8] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

UBYTE HiRepeatable[8] = {
	0x47, 0xF4, 0xFF, 0x03, 0x00, 0x00, 0x00, 0x00
};

struct KeyMap KeyMap = {
	(APTR)LoKeyMapTypes,
	(APTR)LoKeyMap,
	(APTR)LoCapsable,
	(APTR)LoRepeatable,
	(APTR)HiKeyMapTypes,
	(APTR)HiKeyMap,
	(APTR)HiCapsable,
	(APTR)HiRepeatable
};



